<?php 

// modificato da Valerio Locatelli www.advanceweare.it :: valerio@advanceweare.it 
class ControllerPaymentSella extends Controller {
	private $error = array(); 
//
//
	public function index() {
		
		$this->load->language('payment/sella');
		
		//1.5.0 modifiche

	$this->document->setTitle($this->language->get('heading_title'));
		
		$this->load->model('setting/setting');
			
		if (($this->request->server['REQUEST_METHOD'] == 'POST') && ($this->validate())) {
			$this->load->model('setting/setting');
			
			$this->model_setting_setting->editSetting('sella', $this->request->post);				
			
			$this->session->data['success'] = $this->language->get('text_success');
			
			$this->redirect(HTTPS_SERVER . 'index.php?route=extension/payment&token='.$this->session->data['token']);
		}

		$this->data['heading_title'] = $this->language->get('heading_title');

		$this->data['text_enabled'] = $this->language->get('text_enabled');
		$this->data['text_disabled'] = $this->language->get('text_disabled');
		$this->data['text_yes'] = $this->language->get('text_yes');
		$this->data['text_no'] = $this->language->get('text_no');
		// per 1.5.x
		$this->data['text_all_zones'] = $this->language->get('text_all_zones');
		
		$this->data['entry_merchant'] = $this->language->get('entry_merchant');
		$this->data['entry_order_status'] = $this->language->get('entry_order_status');
		$this->data['entry_status'] = $this->language->get('entry_status');
		$this->data['entry_sort_order'] = $this->language->get('entry_sort_order');
		$this->data['entry_test'] = $this->language->get('entry_test');
		$this->data['button_save'] = $this->language->get('button_save');
		$this->data['button_cancel'] = $this->language->get('button_cancel');
		// modifiche per 1.5.x
		$this->data['entry_geo_zone'] = $this->language->get('entry_geo_zone');

		$this->data['tab_general'] = $this->language->get('tab_general');

		if (isset($this->error['warning'])) {
			$this->data['error_warning'] = $this->error['warning'];
		} else {
			$this->data['error_warning'] = '';
		}
		
		if (isset($this->error['merchant'])) {
			$this->data['error_merchant'] = $this->error['merchant'];
		} else {
			$this->data['error_merchant'] = '';
		}

  		$this->document->breadcrumbs = array();

   		$this->document->breadcrumbs[] = array(
       		'href'      => HTTPS_SERVER.('index.php?route=common/home'),
       		'text'      => $this->language->get('text_home'),
      		'separator' => FALSE
   		);

   		$this->document->breadcrumbs[] = array(
       		'href'      => HTTPS_SERVER.('index.php?route=extension/payment'),
       		'text'      => $this->language->get('text_payment'),
      		'separator' => ' :: '
   		);

   		$this->document->breadcrumbs[] = array(
       		'href'      => HTTPS_SERVER.('index.php?route=payment/sella'),
       		'text'      => $this->language->get('heading_title'),
      		'separator' => ' :: '
   		);
		
		$this->data['action'] = HTTPS_SERVER.('index.php?route=payment/sella&token='.$this->session->data['token']);
		
		$this->data['cancel'] = HTTPS_SERVER.('index.php?route=extension/payment');
		
		if (isset($this->request->post['sella_merchant'])) {
			$this->data['sella_merchant'] = $this->request->post['sella_merchant'];
		} else {
			$this->data['sella_merchant'] = $this->config->get('sella_merchant');
		}
		
		if (isset($this->request->post['sella_test'])) {
			$this->data['sella_test'] = $this->request->post['sella_test'];
		} else {
			$this->data['sella_test'] = $this->config->get('sella_test');
		}

		$this->load->model('localisation/order_status');
		
		$this->data['order_statuses'] = $this->model_localisation_order_status->getOrderStatuses();
		
		if (isset($this->request->post['sella_order_status_id'])) {
			$this->data['sella_order_status_id'] = $this->request->post['sella_order_status_id'];
		} else {
			$this->data['sella_order_status_id'] = $this->config->get('sella_order_status_id'); 
		}
			
		if (isset($this->request->post['sella_status'])) {
			$this->data['sella_status'] = $this->request->post['sella_status'];
		} else {
			$this->data['sella_status'] = $this->config->get('sella_status');
		}
		
		
		// modifiche per 1.5.x

		
		
		if (isset($this->request->post['sella_geo_zone_id'])) {
			$this->data['sella_geo_zone_id'] = $this->request->post['sella_geo_zone_id'];
		} else {
			$this->data['sella_geo_zone_id'] = $this->config->get('sella_geo_zone_id');
		}

		$this->load->model('localisation/geo_zone');

		$this->data['geo_zones'] = $this->model_localisation_geo_zone->getGeoZones();
		
		// ---- fine modifiche per 1.5.x
		
		if (isset($this->request->post['sella_sort_order'])) {
			$this->data['sella_sort_order'] = $this->request->post['sella_sort_order'];
		} else {
			$this->data['sella_sort_order'] = $this->config->get('sella_sort_order');
		}

		$this->template = 'payment/sella.tpl';
		$this->children = array(
			'common/header',	
			'common/footer'	
		);
		
		$this->response->setOutput($this->render(TRUE), $this->config->get('config_compression'));

	}

	private function validate() {
		if (!$this->user->hasPermission('modify', 'payment/sella')) {
			$this->error['warning'] = $this->language->get('error_permission');
		}
		
		if (!$this->request->post['sella_merchant']) {
			$this->error['merchant'] = $this->language->get('error_merchant');
		}
		
	
		
		if (!$this->error) {
			return TRUE;
		} else {
			return FALSE;
		}	
	}
}
?>