<?php
class ControllerPaymentSella extends Controller {
	protected function index() {
    	$this->data['button_confirm'] = $this->language->get('button_confirm');
		$this->data['button_back'] = $this->language->get('button_back');

		$this->data['action'] = 'Sella/request.php';
		
		$this->load->model('checkout/order');
		
		$order_info = $this->model_checkout_order->getOrder($this->session->data['order_id']);
		
		$this->load->library('encryption');
		
		$this->data['business'] = $this->config->get('sella_merchant');
		$this->data['item_name'] = $this->config->get('config_store');	
		
		// modificato per 1.5.1
		
		if ($order_info) {
			$currencies = array(
				'AUD',
				'CAD',
				'EUR',
				'GBP',
				'JPY',
				'USD',
				'NZD',
				'CHF',
				'HKD',
				'SGD',
				'SEK',
				'DKK',
				'PLN',
				'NOK',
				'HUF',
				'CZK',
				'ILS',
				'MXN',
				'MYR',
				'BRL',
				'PHP',
				'TWD',
				'THB',
				'TRY'
			);
			
			if (in_array($order_info['currency_code'], $currencies)) {
				$currency = $order_info['currency_code'];
			} else {
				$currency = 'EUR';
			}		
		//$this->data['currency_code'] = $order_info['currency'];
		$this->data['currency_code'] = $currency;
		
		// $total = $this->currency->format($order_info['total'] - $this->cart->getSubTotal(), $currency, false, false);
		$this->data['amount'] = $this->currency->format($order_info['total'], $currency, FALSE, FALSE);
		$this->data['first_name'] = $order_info['payment_firstname'];
		$this->data['last_name'] = $order_info['payment_lastname'];
		$this->data['address1'] = $order_info['payment_address_1'];
		$this->data['address2'] = $order_info['payment_address_2'];
		$this->data['city'] = $order_info['payment_city'];
		$this->data['zip'] = $order_info['payment_postcode'];
		$this->data['country'] = $order_info['payment_country'];
		$this->data['id_order'] =  $this->session->data['order_id'];
		$this->data['email'] = $order_info['email'];
		$this->data['invoice'] = $this->session->data['order_id'] . ' - ' . $order_info['payment_firstname'] . ' ' . $order_info['payment_lastname'];
		$this->data['lc'] = $this->language->get('code');
		if ($this->config->get('sella_test')) {
    		$this->data['url_sella'] = 'testecomm.sella.it';
  		} else {
			$this->data['url_sella'] = 'ecomm.sella.it';
		}
			
		$this->data['return'] = HTTPS_SERVER.('index.php?route=checkout/success');
		$this->data['cancel_return'] = HTTPS_SERVER.('index.php?route=checkout/payment');

		$this->data['back'] = HTTPS_SERVER.('index.php?route=checkout/payment');
		
		$this->id       = 'payment';
		$this->template = $this->config->get('config_template') . '/template/payment/sella.tpl';
		
		$this->render();		
	}
	}
	
	public function confirm() {
		$this->load->library('encryption');
		$encryption = new Encryption($this->config->get('config_encryption'));
		$order_id = $this->request->get['order_id'];

		$this->load->model('checkout/order');

		$order_info = $this->model_checkout_order->getOrder($order_id);

    	$this->model_checkout_order->confirm($order_id, $this->config->get('sella_order_status_id'));

		header("location:".HTTPS_SERVER.('index.php?route=checkout/success'));
	}
	
	public function error() {
		
		$this->load->language('checkout/failure');
		$this->load->language('payment/sella');
		
		$this->document->title = $this->language->get('heading_title');
		
		$this->document->breadcrumbs = array(); 

      	$this->document->breadcrumbs[] = array(
        	'href'      => HTTPS_SERVER.('index.php?route=common/home'),
        	'text'      => $this->language->get('text_home'),
        	'separator' => FALSE
      	); 

      	$this->document->breadcrumbs[] = array(
        	'href'      => HTTPS_SERVER.('index.php?route=checkout/cart'),
        	'text'      => $this->language->get('text_basket'),
        	'separator' => $this->language->get('text_separator')
      	);

      	$this->document->breadcrumbs[] = array(
        	'href'      => HTTPS_SERVER.('index.php?route=checkout/shipping'),
        	'text'      => $this->language->get('text_shipping'),
        	'separator' => $this->language->get('text_separator')
      	);
     
		
    	$this->data['heading_title'] = $this->language->get('heading_title');
		if (isset($_GET['status']))://se c'è lo status
        if ($this->request->get['status'] == "xx")
        {
            $this->data['text_message'] = sprintf($this->language->get('text_error2'), HTTPS_SERVER.('account/account'), $this->url->HTTPS_SERVER.('account/history'), HTTPS_SERVER.('information/contact'));
        }
        else
        {
            $this->data['text_message'] = sprintf($this->language->get('text_error'), HTTPS_SERVER.('index.php?route=account/account'), HTTPS_SERVER.('index.php?route=account/history'), HTTPS_SERVER.('index.php?route=information/contact'));
        }
		else://se non c'è lo status
			$this->data['text_message'] = sprintf($this->language->get('text_error'), HTTPS_SERVER.('index.php?route=account/account'), HTTPS_SERVER.('index.php?route=account/history'), HTTPS_SERVER.('index.php?route=information/contact'));
		endif;
		//$this->data['text_message'] = "NO";
    	$this->data['button_continue'] = $this->language->get('button_continue');

    	$this->data['continue'] = HTTPS_SERVER.('index.php?route=common/home');

		$this->data['button_confirm']      = $this->language->get('button_confirm');
		$this->data['button_back']          = $this->language->get('button_back');
		
		$this->id = 'payment';
		if (file_exists(DIR_TEMPLATE . $this->config->get('config_template') . '/template/payment/sella_error.tpl')) {
			$this->template = $this->config->get('config_template') . '/template/payment/sella_error.tpl';
		} else {
			$this->template = 'default/template/payment/sella_error.tpl';
		}
		
		$this->children = array(
			'common/header',
			'common/footer',
			'common/column_left',
			'common/column_right'
		);
		
		$this->response->setOutput($this->render(TRUE), $this->config->get('config_compression'));

  	}
}
?>
